Subject: Re: [bitcoin-dev] On the regularity of soft forks

From: ZmnSCPxj <[email-masked]>
Date: Mon, 11 Oct 2021 19:53:39 +0000

Good morning Jeremy,

> This also has strong precedent in other important technical bodies, e.g. from https://datatracker.ietf.org/doc/html/rfc7282 On Consensus and Humming in the IETF.
>
>   Even worse is the "horse-trading" sort of compromise: "I object to
>    your proposal for such-and-so reasons.  You object to my proposal for
>    this-and-that reason.  Neither of us agree.  If you stop objecting to
>    my proposal, I'll stop objecting to your proposal and we'll put them
>    both in."  That again results in an "agreement" of sorts, but instead
>    of just one outstanding unaddressed issue, this sort of compromise
>   results in two, again ignoring them for the sake of expedience.
>
>    These sorts of "capitulation" or "horse-trading" compromises have no
>    place in consensus decision making.  In each case, a chair who looks
>    for "agreement" might find it in these examples because it appears
>    that people have "agreed".  But answering technical disagreements is
>    what is needed to achieve consensus, sometimes even when the people 
>
>   who stated the disagreements no longer wish to discuss them.
>
> If you would like to advocate bitcoin development run counter to that, you should provide a much stronger refutation of these engineering norms.

The Internet has the maxim "be strict in what you provide, lenient in what you accept", which allows for slight incompatibilities between software to generally be papered over (xref the mountains of Javascript code that shim in various new ECMAScript features fairly reliably in a wide variety of browsers).

Bitcoin, as a consensus system, requires being paranoiacally strict on what transactions and blocks you accept.
Thus, the general engineering norm of separating concerns, of great application to "lenient in what you accept" systems, may not apply quite as well to "hell no I am not accepting that block" Bitcoin.

Bitcoin as well, as a resistance against state moneys, is inherently political, and it possible that the only way out is through: we may need to resist this horse-trading by other means than separating concerns, including political will to reject capitulation despite bundling.

Regards,
ZmnSCPxj